package cl.uchile.ing.robotomnidireccional;

import android.content.Context;
import android.support.annotation.NonNull;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.util.List;

public class AdaptadorListaVentanas extends RecyclerView.Adapter<AdaptadorListaVentanas.ListaVentanasViewHolder>{

    private List<VentanaItemLista> ListaVentanas;

    AdaptadorListaVentanas(List<VentanaItemLista> LV){
        this.ListaVentanas = LV;
    }

    @NonNull
    @Override
    public ListaVentanasViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        Context Contexto = parent.getContext();
        int IdLayout = R.layout.elemento_menu_rv;
        View Vista = LayoutInflater.from(Contexto).inflate(IdLayout,parent,false);
        return new ListaVentanasViewHolder(Vista);
    }

    @Override
    public void onBindViewHolder(@NonNull ListaVentanasViewHolder LVViewHolder, int position) {
        VentanaItemLista ItemLista = ListaVentanas.get(position);
        LVViewHolder.TituloVentana.setText(ItemLista.getTexto());
    }

    @Override
    public int getItemCount(){
        return ListaVentanas.size();
    }

    public class ListaVentanasViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener{
        private TextView TituloVentana;

        private ListaVentanasViewHolder(View ItemView){
            super(ItemView);
            ItemView.setOnClickListener(this);
            TituloVentana = ItemView.findViewById(R.id.TextoMenu);
        }

        @Override
        public void onClick(View vista) {
            int Posicion = getAdapterPosition();
            if (Posicion == 0){ Funciones.AbrirActivity(Principal.class,vista.getContext()); }
            if (Posicion == 1){ Funciones.AbrirActivity(Motores.class,vista.getContext()); }
        }
    }
}
