package cl.uchile.ing.robotomnidireccional;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.ToggleButton;

public class Motores extends AppCompatActivity implements SeekBar.OnSeekBarChangeListener, ToggleButton.OnCheckedChangeListener{

    private TextView TextoRPM1;
    private TextView TextoRPM2;
    private TextView TextoRPM3;
    private ToggleButton Switch;
    private Button Enviar;
    private int RPM1 = 0;
    private int RPM2 = 0;
    private int RPM3 = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_motores);

        SeekBar BarraMot1 = findViewById(R.id.BarraMotor1);
        SeekBar BarraMot2 = findViewById(R.id.BarraMotor2);
        SeekBar BarraMot3 = findViewById(R.id.BarraMotor3);
        TextoRPM1 = findViewById(R.id.RPMMot1);
        TextoRPM2 = findViewById(R.id.RPMMot2);
        TextoRPM3 = findViewById(R.id.RPMMot3);
        Enviar = findViewById(R.id.EnvioDatosMotor);
        Switch = findViewById(R.id.BotonEnvioConstante);
        BarraMot1.setOnSeekBarChangeListener(this);
        BarraMot2.setOnSeekBarChangeListener(this);
        BarraMot3.setOnSeekBarChangeListener(this);
        Switch.setOnCheckedChangeListener(this);
    }

    public void InstruccionesRPM(View IRPM){
        EnviarRPMSSerial(true);}

    public void InstruccionFreno(View FRN){EnviarASerial("<FRN>",true);}

    public void AbrirMenuVentanas(View AMV) {
        EnviarASerial("<FRN>",true);
        Funciones.AbrirActivity(MenuVentanas.class, getApplicationContext());
    }

    // Método que resume las transmisiones seriales de los botones
    private void EnviarASerial(String Texto, Boolean Toast){
        Funciones.TransmitirSerial(Texto,getApplicationContext(),Toast);
    }

    private void EnviarRPMSSerial(Boolean Toast){
        EnviarASerial("<MMT,"+RPM1+","+RPM2+","+RPM3+">",Toast);
    }

    @Override
    public void onProgressChanged(SeekBar Barra, int Valor, boolean B) {
        Boolean SON = Switch.isChecked();
        String Texto;
        switch (Barra.getId()){
            case R.id.BarraMotor1:
                RPM1 = Valor-50;
                Texto = "RPM 1: "+RPM1;
                TextoRPM1.setText(Texto);
                if (SON) {EnviarRPMSSerial(false);}
                break;
            case R.id.BarraMotor2:
                RPM2 = Valor-50;
                Texto = "RPM 2: "+RPM2;
                TextoRPM2.setText(Texto);
                if (SON) {EnviarRPMSSerial(false);}
                break;
            case R.id.BarraMotor3:
                RPM3 = Valor-50;
                Texto = "RPM 3: "+RPM3;
                if (SON) {EnviarRPMSSerial(false);}
                TextoRPM3.setText(Texto);
        }
    }

    @Override
    public void onStartTrackingTouch(SeekBar Barra) {}
    @Override
    public void onStopTrackingTouch(SeekBar Barra) {}

    @Override
    public void onCheckedChanged(CompoundButton Boton, boolean Constante){
        if (Constante){
            EnviarRPMSSerial(true);
            Enviar.setEnabled(false);
        }
        else {Enviar.setEnabled(true);}
    }
}
